#ifndef TIMELINE_H
#define TIMELINE_H

#include <SFML/Graphics/RenderWindow.hpp>
#include <SFML/Config.hpp>
#include <memory>

using microsec = sf::Int64;

class Note;

class Timeline
{
public:

    using Iterator = std::vector<Note*>::const_iterator;

    virtual ~Timeline() = default;

    virtual void update() = 0;
    virtual void run(std::vector<Note*>&& notes, const microsec& visibility) = 0;
    virtual void clear() = 0;

    virtual microsec currentMusicOffset() const = 0;
    virtual void drawVisibleNotes() const = 0;
};

#endif // TIMELINE_H
