#include "classicgraphicsmanager.h"
#include "classicnote.h"

ClassicGraphicsManager::ClassicGraphicsManager(sf::RenderTarget& target) :
    _sprite_container({Type::UP, Type::DOWN,
                      Type::LEFT, Type::RIGHT},
                      std::make_unique<ClassicSpriteFactory>("VeraMono.ttf")),
    _render_target(target)
{}

void ClassicGraphicsManager::initSprite(ClassicNote* note)
{
    note->setSprite(_sprite_container.getSprite(note->type()));
}

void ClassicGraphicsManager::resetSprite(ClassicNote* note)
{
    _sprite_container.resetSprite(note->sprite(), note->type());
}

void ClassicGraphicsManager::draw(const ClassicNote *note)
{
    _render_target.draw(*note->sprite());
}
