#ifndef CLASSICMAPCREATOR_H
#define CLASSICMAPCREATOR_H

#include <vector>

#include "note.h"
#include "classicgraphicsmanager.h"

struct Beatmap
{
    std::vector<Note*> notes;
    microsec visibility_offset;
};

class ClassicMapCreator
{
public:
    explicit ClassicMapCreator(const std::unique_ptr<ClassicGraphicsManager>& manager);

     Beatmap createBeatmap(const std::string& filepath) const;

private:
    const std::unique_ptr<ClassicGraphicsManager>& _graphics_manager;
};

#endif // CLASSICMAPCREATOR_H
